#include<bits/stdc++.h>
using namespace std;
int n,h,a[10000][10000],vrednosti[10000][10000];
int brnulalevo,p,brnuladesno,sumagornjih,pomocni;
vector<int> v,kojifale;
int main()
{
    cin>>h>>n;
    for(int i=1;i<=h;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cin>>a[i][j];
        }
    }
    for(int j=1;j<=n;j++)
    {
        vrednosti[1][j]=1;
        if(a[1][j]==0){vrednosti[1][j]=0;}
    }
    for(int i=1;i<=h;i++)
    {
        a[i][n+1]=-1;
    }
    for(int i=1;i<=h;i++)
    {
        a[i][0]=-1;
    }
    for(int i=0;i<=n;i++)
    {
        a[0][i]=1;
    }
    //cout<<endl<<endl;
    for(int i=1;i<=1;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(a[i][j]!=0){vrednosti[i][j]+=vrednosti[i-1][j];}
            if(i==1)
            {
                if(a[i][j]==1){vrednosti[i][j]=1;}
                if(a[i][j]==0)
                {
                p=j;
                while(a[i][j]==0)
                {
                    //sumagornjih+=vrednosti[i-1][j];
                    brnuladesno++;
                    j++;
                }
                //j=p;
                }
                //cout<<brnuladesno<<" "<<p<<endl;
                if(brnuladesno+p-1<n and p-1>=1){vrednosti[i][p-1]+=brnuladesno;brnuladesno=0;}
                if(brnuladesno+p-1==n){vrednosti[i][p-1]+=brnuladesno;brnuladesno=0;}
                if(p-1<1){vrednosti[i][j]+=brnuladesno;brnuladesno=0;}
            }
            sumagornjih=0;
            brnuladesno=0;
            brnulalevo=0;
        }
    }
    for(int i=1;i<=h;i++)
    {
        for(int j=1;j<=n;j++)
        {
            brnuladesno=0;
            brnulalevo=0;
            sumagornjih=0;
                if(a[i][j]==0)
                {
                    //cout<<i<<" "<<j<<" "<<brnulalevo<<" "<<sumagornjih<<endl;
                    p=j;
                    while(a[i][j]==0 and j<=n)
                    {
                        brnulalevo++;
                        sumagornjih+=vrednosti[i-1][j];
                        j++;
                        if(a[i][j]==1){break;}
                    }
                    if(i%2==0 or i%2!=0)                                    //////////VAMO SU PARNI jos je ovo ostalo valjda 3 primer
                    {
                        //cout<<i<<" "<<p<<" "<<j<<" "<<sumagornjih<<" ";
                        if(brnulalevo+p-1<n and p-1>=1)
                        {
                            if(sumagornjih%2==0)
                            {
                                vrednosti[i][p-1]+=sumagornjih/2;
                                vrednosti[i][brnulalevo+p]+=sumagornjih/2;
                            }
                            else
                            {
                                if(i%2==0)
                                {
                                vrednosti[i][p-1]+=sumagornjih/2;
                                vrednosti[i][brnulalevo+p]+=sumagornjih/2+1;
                                }
                                else
                                {
                                    vrednosti[i][p-1]+=sumagornjih/2+1;
                                    vrednosti[i][brnulalevo+p]+=sumagornjih/2;
                                }
                            }
                        }
                        if(brnulalevo+p-1==n)
                        {
                            vrednosti[i][p-1]+=sumagornjih;
                        }
                        if(p-1<1)
                        {
                            vrednosti[i][brnulalevo+p]+=sumagornjih;
                        }
                        //cout<<vrednosti[i][j-1]<<" "<<vrednosti[i][brnulalevo+j]<<endl<<endl;
                    }
                    //cout<<i<<" "<<j<<endl;
                }
                if(a[i][j]!=0){vrednosti[i][j]+=vrednosti[i-1][j];}
                sumagornjih=0;
                brnuladesno=0;
                brnulalevo=0;

        }
    }
    for(int i=h;i<=h;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cout<<vrednosti[i][j]<<" ";
        }
        cout<<endl;
    }
}